# Timing tests:

test.name <- "vec-subset.vec-by-scalar"

a <- seq(0,1,length=200)
k <- 1:200
l <- rep(c(TRUE,FALSE,TRUE,TRUE),50)
z <- a + 1i
r <- 2.1

f <- test.cmp (function () { for (i in 1:500000) b <<- a[1] + a[r] + a[3L] })
sys.time(f())
print(b)

f <- test.cmp (function () { for (i in 1:500000) b <<- k[1] + k[r] + k[3L] })
sys.time(f())
print(b)

f <- test.cmp (function () { for (i in 1:500000) b <<- l[1] | l[r] | l[3L] })
sys.time(f())
print(b)

f <- test.cmp (function () { for (i in 1:500000) b <<- z[1] + z[r] + z[3L] })
sys.time(f())
print(b)

f <- test.cmp (function () { for (i in 1:500000) a[r] <<- a[1] + a[3] })
sys.time(f())
print(a[r])

test.name <- "vec-subset.vec-by-vec"

a <- seq(0,1,length=1000)
w <- 101:200
x <- 1:100
y <- seq(1,200,by=2)
z <- seq(1,200,by=2) + 0.1

f <- test.cmp (function () { for (i in 1:1000000) b <<- a[10:12] + a[110:112] })
sys.time(f())
print(sum(b))

f <- test.cmp (function () { for (i in 1:300000) b <<- a[1:100] + a[101:200] })
sys.time(f())
print(sum(b))

f <- test.cmp (function () { for (i in 1:200000) b <<- a[11:510] + a[401:900]})
sys.time(f())
print(sum(b))

f <- test.cmp (function () { for (i in 1:300000) b <<- a[x] + a[w] })
sys.time(f())
print(sum(b))

f <- test.cmp (function () { for (i in 1:300000) b <<- a[x] + a[51:150] })
sys.time(f())
print(sum(b))

f <- test.cmp (function () { for (i in 1:300000) b <<- a[y] + a[51:150] })
sys.time(f())
print(sum(b))

f <- test.cmp (function () { for (i in 1:300000) b <<- a[z] + a[51:150] })
sys.time(f())
print(sum(b))

f <- test.cmp (function () { for (i in 1:300000) a[101:150] <<- a[1:50] })
sys.time(f())
print(sum(a))

test.name <- "vec-subset.vec-by-neg"

f <- test.cmp (function () { for (i in 1:100000) b <<- a[-(1:5)] + a[-(5:9)] })
sys.time(f())
print(sum(b))

f <- test.cmp (function () { for (i in 1:100000) b <<- a[-1] + a[-100] })
sys.time(f())
print(sum(b))

test.name <- "vec-subset.mat-by-scalar"

A <- matrix(seq(0,1,length=150000),300,500)
r <- 2.1

f <- test.cmp (function () { for (i in 1:500000) b <<- A[3,4] + A[r,10] })
sys.time(f())
print(b)

f <- test.cmp (function () { for (i in 1:500000) b <<- A[3L,4L] + A[r,10L] })
sys.time(f())
print(b)

f <- test.cmp (function () { for (i in 1:500000) A[3,4] <<- A[r,10] })
sys.time(f())
print(A[3,4])

test.name <- "vec-subset.mat-by-vec"

A <- matrix(seq(0,1,length=150000),300,500)

f <- test.cmp (function () { for (i in 1:20000) B <<- A[100:200,300:400] })
sys.time(f())
print(c(sum(B),sum(B[10,]),sum(B[,10])))

f <- test.cmp (function () { for (i in 1:500000) v <<- A[10,300:400] })
sys.time(f())
print(c(sum(v),sum(exp(v))))

f <- test.cmp (function () { for (i in 1:500000) v <<- A[100:200,10] })
sys.time(f())
print(c(sum(v),sum(exp(v))))

f <- test.cmp (function () { for (i in 1:300000) v <<- A[10:11,] })
sys.time(f())
print(c(sum(v),sum(exp(v))))

f <- test.cmp (function () { for (i in 1:300000) v <<- A[,10:11] })
sys.time(f())
print(c(sum(v),sum(exp(v))))

f <- test.cmp (function () { for (i in 1:10000) v <<- A[-10,100:200] })
sys.time(f())
print(c(sum(v),sum(exp(v))))

f <- test.cmp (function () { for (i in 1:10000) v <<- A[100:200,-10] })
sys.time(f())
print(c(sum(v),sum(exp(v))))

f <- test.cmp (function () { for (i in 1:20000) A[101:130,301:400] <<- 99 })
sys.time(f())
print(sum(A))

# Correctness checks:

a <- c(aa=10,bb=20,cc=30,dd=40)
print(a[c(2,0,5,1)])
print(a[-2])
print(a[c("cc","aa","cc","ee")])

a[c("aa","ee")] <- c(100,500)
print(a)

M <- matrix(1:15,3,5)
print(M[c(2,NA,1,1),c(5,2,NA,5,3,NA)])

M[2:3,1:2] <- 999
print(M)

m <- matrix(1:12,3,4)
print(m[drop=1:1,2:3])

